//
//  EffectView.m
//

#import "EffectView.h"


@implementation EffectView

@synthesize	isLoop;
@synthesize isFinishDelete;

- (id)initWith:(UIImage*)image {
	
	CGRect	rect = CGRectMake(0, 0, image.size.width, image.size.height);
    if (self = [super initWithFrame:rect]) {
		self.layer.contents = (id)image.CGImage;
		isLoop = NO;
		isFinishDelete = YES;
    }
    return self;
}

- (void)dealloc {
    [super dealloc];
}


//位置のアニメーション
- (void)setAnimePosition:(CGPoint)toPoint Duration:(CGFloat)dur
{
	CABasicAnimation*	anime = [CABasicAnimation animationWithKeyPath:@"position"];
	CGPoint	fromPt = self.layer.position;
	anime.duration = dur;
	anime.fromValue = [NSValue valueWithCGPoint:fromPt];
	anime.toValue = [NSValue valueWithCGPoint:toPoint];		
	anime.delegate = self;
	anime.autoreverses = isLoop;
	if(isLoop)
		anime.repeatCount = 10000;
	[self.layer addAnimation:anime forKey:@"animatePosition"];
	CGRect			aFrame = [self frame];
	CGPoint			nowPt = toPoint;
	isPosition = YES;
	//if( isLoop || isFinishDelete )
		[self.layer setFrame:CGRectMake(nowPt.x-(aFrame.size.width/2), nowPt.y-(aFrame.size.height/2), aFrame.size.width, aFrame.size.height)];
}


//透明度のアニメーション
- (void)setAnimeOpacityFrom:(CGFloat)opa1 To:(CGFloat)opa2 Duration:(CGFloat)dur
{
	CABasicAnimation*	opacity = [CABasicAnimation animationWithKeyPath:@"opacity"];
	opacity.fromValue = [NSNumber numberWithFloat:opa1];
	opacity.toValue = [NSNumber numberWithFloat:opa2];
	opacity.delegate = self;
	opacity.duration = dur;
	opacity.autoreverses = isLoop;
	if(isLoop)
		opacity.repeatCount = 10000;
	[self.layer addAnimation:opacity forKey:@"animateOpacity"];
	isOpacity = YES;
	//if( isLoop || isFinishDelete )
		self.layer.opacity = opa2;
}

//矩形サイズのアニメーション
- (void)setAnimeBoundsScaleFrom:(CGFloat)scl1 To:(CGFloat)scl2 Duration:(CGFloat)dur
{
	CABasicAnimation*	animeBounds;
	CGRect				fromRect;
	CGRect				toRect;
	
	animeBounds = [CABasicAnimation animationWithKeyPath:@"bounds"];
	fromRect = CGRectMake(self.layer.bounds.origin.x, self.layer.bounds.origin.y, self.layer.bounds.size.width*scl1, self.layer.bounds.size.height*scl1);
	toRect   = CGRectMake(self.layer.bounds.origin.x, self.layer.bounds.origin.y, self.layer.bounds.size.width*scl2, self.layer.bounds.size.height*scl2);
	animeBounds.fromValue = [NSValue valueWithCGRect:fromRect];
	animeBounds.toValue = [NSValue valueWithCGRect:toRect];		
	animeBounds.duration = dur;
	animeBounds.delegate = self;
	animeBounds.autoreverses = isLoop;
	if( isLoop || isFinishDelete )
		animeBounds.repeatCount = 10000;
	[self.layer addAnimation:animeBounds forKey:@"animateBounds"];
	isBounds = YES;
	//if( isLoop || isFinishDelete )
		self.layer.bounds = toRect;
}


#pragma mark -

- (void)animationDidStop:(CAAnimation *)theAnimation finished:(BOOL)flag
{
	if(isOpacity)
		isOpacity = NO;
	if(isPosition)
		isPosition = NO;
	if(isBounds)
		isBounds = NO;
	
	if( isOpacity==NO && isPosition==NO && isBounds==NO && isFinishDelete )
		[self removeFromSuperview];
}

@end
