
#import "GameBoardTile.h"

@implementation GameBoardTile

@synthesize contentImage;
@synthesize frame;
@synthesize tileIndex;
@synthesize state;
@synthesize piece;
@synthesize item;

+(GameBoardTile*)gameBoardTileWith:(CGRect)tframe State:(int)tileState;
{
	GameBoardTile*	tile = [[GameBoardTile alloc] initWithTileFrame:tframe State:tileState];
	return	[tile autorelease];
}

////////////////////////////////////////////////////////
//初期化
////////////////////////////////////////////////////////
-(id)initWithTileFrame:(CGRect)tframe State:(int)tileState
{
	self = [super init];
	if( self ) {
		self.frame = tframe;
		self.state = tileState;
	}
	return	self;
}

////////////////////////////////////////////////////////
//解放
////////////////////////////////////////////////////////
-(void) dealloc
{
	[contentImage release];
	[super dealloc];
}

////////////////////////////////////////////////////////
//コンテキストにタイルイメージを描画
////////////////////////////////////////////////////////
-(void)drawTile:(CGContextRef)context
{
	if( contentImage ){
		UIGraphicsPushContext(context);
		CGSize	size = contentImage.size;
		[contentImage drawAtPoint:CGPointMake(frame.origin.x+((frame.size.width-size.width)/2), frame.origin.y+((frame.size.height-size.height)/2))];
		UIGraphicsPopContext();
	}
}

////////////////////////////////////////////////////////
//フレームの中心点（タイル）
////////////////////////////////////////////////////////
-(CGPoint)center
{
	return	CGPointMake(CGRectGetMidX(frame), CGRectGetMidY(frame));
}


////////////////////////////////////////////////////////
//タイルヒットチェック
////////////////////////////////////////////////////////
-(BOOL)tileCheck:(CGPoint)point
{
	BOOL	ret = NO;
	if( CGRectContainsPoint(frame, point) ) {
		ret = YES;
	}
	return	ret;
}


@end
